function us=shift(typ,u)
//{\it decale le tableau u de +1 ou -1}
//{\it avec condition aux limites de Dirichlet}
select typ
   case '+1' then          //{\it shift +1}
           [m,n] = size(u) ;
           us(1:n-1) = u(2:n) ;
           us(n) = 0. ;
   case '-1' then          //{\it shift -1}
           [m,n] = size(u) ;
           us(2:n) = u(1:n-1) ;
           us(1) = 0. ;
   else 
           error('shift de +1 ou -1 ?')
end;
endfunction;

function us=shiftp(typ,u)
//{\it decale le tableau u de +1 ou -1}
//{\it avec condition aux limites periodiques}
select typ
   case '+1' then          //{\it shift +1}
           [m,n] = size(u) ;
           us(1:n-1) = u(2:n) ;
           us(n) = u(1) ;
   case '-1' then          //{\it shift -1}
           [m,n] = size(u) ;
           us(2:n) = u(1:n-1) ;
           us(1) = u(n) ;
   else 
           error('shift de +1 ou -1 ?')
end;
endfunction;

function us=shift2d(typ,u)
//{\it decale le tableau u de +1 ou -1}
//{\it dans les directions nord, sud, est, ouest}
//{\it avec condition aux limites de Dirichlet}
select typ
   case 'n' then          //{\it shift nord}
           [m,n] = size(u) ;
           us(1:m,1:n-1) = u(1:m,2:n) ;
           us(1:m,n) = 0. ;
   case 's' then          //{\it shift sud}
           [m,n] = size(u) ;
           us(1:m,2:n) = u(1:m,1:n-1) ;
           us(1:m,1) = 0. ;
   case 'e' then          //{\it shift est}
           [m,n] = size(u) ;
           us(1:m-1,1:n) = u(2:m,1:n) ;
           us(m,1:n) = 0. ;
   case 'o' then          //{\it shift ouest}
           [m,n] = size(u) ;
           us(2:m,1:n) = u(1:m-1,1:n) ;
           us(1,1:n) = 0. ;
   else 
           error('shift nord, sud, est, ouest ?')
end;
endfunction;

function y=creneau(x)
	y=(abs(x)<3)*2-1;
endfunction;

function y=bosse(x)
	y= max(0.,1.-x**2);
endfunction;

function y=noyau(x,t)
	y=exp(-x**2/(4*t))/sqrt(4*%pi*t);
endfunction;

function y=phase(x,lg)
	y=x-2*lg*int((x-lg)/(2*lg));
endfunction;

function f=source(x,y)
	f=(50*(((x-0.5)**2)'*ones(y)+ones(x)'*((y-0.5)**2)) < 1)*5;
endfunction;
